## imwheel 0.9.6

=== Makefile ===
# IMWheel Makefile
# best used with gmake!

VERSION=0.9.6

.PHONY: jax getopt

CC=gcc

ifeq ("$(shell uname -s)","Linux")
INCDIRS=-I/usr/X11R6/include -Ijax
LIBDIRS=-L/usr/X11R6/lib
SUBDIRLIBS=jax/libjax.a
SUBDIRS=jax
LIBS=-lX11 -lXext -lXtst
ifeq ("$(shell ls -d gpm-imwheel)","gpm-imwheel")
GPM=gpm
endif
else
SHELL=`which bash`
INCDIRS=-I/usr/X11R6/include -Ijax -Igetopt
LIBDIRS=-L/usr/X11R6/lib
SUBDIRLIBS=jax/libjax.a getopt/libgetopt.a
SUBDIRS=jax getopt
LIBS=-lX11 -lXext -lXtst
GPM=
endif

#FLAGS=-g -DDEBUG -Wall
#FLAGS=-g -pg
FLAGS=-O6 -s -Wall
INSTALLDIR=/usr/local/bin
# No spaces are allowd before or after the PIDDIR directory
#PIDDIR=/var/run#NOTE : this is great for root users... but regular users
               # have no access here which is when the program needs to be
               # setuid root... only do this if you are prepared to have
               # another setuid root program in your install base.
PIDDIR=/tmp#NOTE : This has been voted by a large majority to be the best
           # place for this file. for the good of all users.
CFLAGS=$(FLAGS) $(INCDIRS) -DPIDDIR="\"$(PIDDIR)\"" -DVERSION="\"$(VERSION)\""
LDFLAGS=$(FLAGS) $(LIBDIRS) $(LIBS)
SHELL=/bin/sh
PROGS= imwheel $(GPM) mdump setimps2 getmdt setmmplus setps2

all: $(SUBDIRS) $(PROGS)

gpm-imwheel/Makefile:
	cd gpm-imwheel ; ./configure

gpm: gpm-imwheel/Makefile
	@make -C gpm-imwheel

imwheel: imwheel.o util.o cfg.o $(SUBDIRLIBS)

jax:
	@make -C jax

getopt:
	@make -C getopt

imwheel.o: imwheel.c util.h

new: clean all

texts:
	set -x ; for f in README BUGS CHANGES COPYING ; do cp $$f $$f.tmp ; expand -t4 $$f.tmp > $$f ; rm $$f.tmp ; done ; set +x

tgz: nuke texts full-tgz nogpm-tgz

full-tgz:
	FNAME=`basename $$PWD` ; tar -zcvf ../$$FNAME.tar.gz -C .. $$FNAME

nogpm-tgz:
	FNAME=`basename $$PWD` ; tar -zcvf ../$$FNAME.nogpm.tar.gz -C .. $$FNAME --exclude='imwheel/gpm-*'

clean:
	rm -f *.o

nuke: clean
	rm -f $(PROGS)
	-make -C jax nuke
	-make -C getopt nuke
ifeq ("$(GPM)", "gpm")
	-make -C gpm-imwheel/docs distclean
	-make -C gpm-imwheel distclean
endif

ifeq ("$(GPM)", "gpm")
install: install-gpm install-imwheel

install-gpm: $(GPM)
	@make -C gpm-imwheel install
else
install: install-imwheel
endif

install-imwheel: imwheel
	install -m 755 -s imwheel $(INSTALLDIR)
	@setuid='' ;\
	while [ -z "$$setuid" ] ; do \
		echo -ne '\nShall I setuid root the imwheel executable [N/y]?' ;\
		read setuid ;\
		case "$$setuid" in \
			y|Y) echo '## Setting UID, this is best for non-root usage!' ;\
				echo '## This does not effect usage for root users. (duh!)' ;\
				echo '## This gives all users kill privileges for other imwheel processes.' ;\
				echo 'chown root $(INSTALLDIR)/imwheel' ;\
				chown root $(INSTALLDIR)/imwheel ; \
				echo 'chgrp bin $(INSTALLDIR)/imwheel' ;\
				chgrp bin $(INSTALLDIR)/imwheel ; \
				echo 'chmod 4755 $(INSTALLDIR)/imwheel' ;\
				chmod 4755 $(INSTALLDIR)/imwheel ; \
				setuid=y \
				;;\
			n|N|'') [ $(PIDDIR) = '/var/run' ] && echo '## This may cause problems for users other than root!' || ( echo '## This should be OK...if you have not altered the Makefile! ;)' ; echo '## /tmp is the best place for the pidfile this way.  That'"'"'s the way it is now.') ;\
				setuid=n \
				;;\
			*) setuid='' ;;\
		esac ;\
	done
	@[ -e /etc/imwheelrc ] \
		&& echo "## /etc/imwheelrc already exists, not installing." \
		|| (set -x;install -m 644 -o root imwheelrc /etc/imwheelrc)
	@[ -e $(HOME)/.imwheelrc ] \
		&& echo "## $(HOME)/.imwheelrc already exists, not installing." \
		|| (set -x;install -m 644 imwheelrc $(HOME)/.imwheelrc)
	install -m 644 imwheel.1 /usr/local/man/man1/imwheel.1

mdump: mdump.c
	$(CC) -O6 $^ -o $@

setimps2: setimps2.c
	$(CC) -O6 $^ -o $@

setmmplus: setmmplus.c
	$(CC) -O6 $^ -o $@

getmdt: getmdt.c
	$(CC) -O6 $^ -o $@

=== getopt/Makefile ===
# GetOpt Makefile

CC=gcc
#FLAGS=-g -DDEBUG -Wall
#FLAGS=-g -pg
FLAGS=-O6 -s -Wall
CFLAGS=$(FLAGS)
LDFLAGS=$(FLAGS)
SHELL=`which bash`
LIB=libgetopt.a
OBJS=getopt.o getopt1.o
RANLIB=ranlib

all: $(LIB)

$(LIB): $(OBJS)
	rm -f $(LIB)
	$(AR) -qv $(LIB) $(OBJS)
	$(RANLIB) $(LIB)

new: clean all

clean:
	rm -f *.o

nuke: clean
	rm -f $(LIB)

install: all

=== jax/Makefile ===
CC=gcc -O -s
#CC=gcc -g
INC=-I/usr/openwin/include/X11 -I/usr/X11/include/X11
LIB=-L/usr/openwin/lib/X11 -L/usr/X11/lib
ARCHIVE=*.c *.h Makefile *.1 *.man

all: libjax.a

jax.o : jax.c jax.h
	$(CC) -c jax.c $(INC)

libjax.a: jax.o
	rm -f libjax.a
	ar -q libjax.a jax.o

clean:
	rm -f *.o

nuke:
	rm -f *.o *.a

tgz:
	tar -cvf - $(ARCHIVE) | gzip -c > ../jax.tgz

## imwheel 1.0.0pre12

=== debian/changelog ===
imwheel (1.0.0pre12-14) unstable; urgency=medium

  * QA upload.
  * debian/control: added word 'mouse' to description.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 05 Feb 2022 01:11:23 -0300

imwheel (1.0.0pre12-13) unstable; urgency=medium

  * QA upload.
  * Migrations:
      - debian/copyright to 1.0 format.
      - debian/rules to new (reduced) format.
  * Using new DH level format. Consequently:
      - debian/compat: removed.
      - debian/control: changed from 'debhelper' to 'debhelper-compat' in
        Build-Depends field and bumped level to 13.
  * debian/clean: created to remove a file generated from the build process and
    forgotten by distclean.
  * debian/control:
      - Added 'Rules-Requires-Root: no' to source stanza.
      - Added Vcs-* fields.
      - Bumped Standards-Version to 4.6.0.
      - Removed no longer needed build dependencies dpkg-dev and quilt.
  * debian/imwheel.install: renamed to install.
  * debian/imwheel.prerm:
      - Renamed to prerm.
      - Explicitly add 'set -e'.
  * debian/NEWS: removed all asterisks, as asked by lintian.
  * debian/patches/:
      - Added a numeric prefix to all patch names.
      - build-system-update: dropped. This patch was created in 2010 (revision
        1.0.0pre12-9) to update the autotools files. However, currently, the
        dh_autoreconf do it automatically. Also, this patch will generate a
        FTBFS with DH 13.
      - 070_fix-spelling-errors.patch: created to fix some spelling errors in
        final binary and in manpage.
      - 080_fix-FTCBFS.patch: created to fix a FTCBFS because upstream's
        configure.in uses AC_CHECK_FILE to check for source files. Thanks to
        Helmut Grohne <helmut@subdivi.de>. (Closes: #901986)
  * debian/salsa-ci.yml: added to provide CI tests for Salsa.
  * debian/tests/control: created to provide a superficial CI test.
  * debian/upstream/metadata: created.
  * debian/watch: created.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 04 Feb 2022 17:27:20 -0300

imwheel (1.0.0pre12-12) unstable; urgency=low

  * Orphaning the package.

 -- Christopher Martin <chrsmrtn@debian.org>  Sun, 26 Oct 2014 15:53:50 -0400

imwheel (1.0.0pre12-11) unstable; urgency=low

  * Revert mistaken punctuation changes in the last upload made to
    /etc/X11/Xsession.d/60imwheel_start-imwheel and
    /etc/X11/imwheel/startup.conf (except that 60imwheel_start-imwheel
    will still kill already-running instances of imwheel by default
    when launching). (Closes: #763850)

 -- Christopher Martin <chrsmrtn@debian.org>  Fri, 03 Oct 2014 09:20:30 -0400

imwheel (1.0.0pre12-10) unstable; urgency=low

  * Remove needless quotes around variables in
    /etc/X11/Xsession.d/60imwheel_start-imwheel and in
    /etc/X11/imwheel/startup.conf. If imwheel stops working after
    upgrading, check startup.conf and remove/adjust extra punctuation.
  * Tweak 60imwheel_start-imwheel so that imwheel kills
    already-running instances of itself by default when it launches.
  * Bump standards-version to 3.9.6, and debhelper compatibility level to 9.
    Adjust the build-deps accordingly.
  * Re-jig debian/rules to enable hardening compile flags, and also clean-up
    the same file to address minor lintian warnings.
  * Don't install long-irrelevant 'extra' binaries in /usr/lib/imwheel
    (e.g. mdump). (Closes: #716176)

 -- Christopher Martin <chrsmrtn@debian.org>  Sun, 21 Sep 2014 09:48:27 -0400

imwheel (1.0.0pre12-9) unstable; urgency=low

  * Bump standards-version to 3.8.4, and debhelper compatibility level to 7.
  * Switch to dpkg-source 3.0 (quilt) format. Add quilt to build-deps, and
    convert patches to the quilt system, documenting them as per DEP 3.
    Tweak debian/rules to handle quilt patching/unpatching as well.
  * Add (misc:Depends} to debian/control.
  * Drop 12 year old EMACS setup commentary from /usr/share/docs/imwheel.

 -- Christopher Martin <chrsmrtn@debian.org>  Sat, 20 Feb 2010 09:19:53 -0500

imwheel (1.0.0pre12-8) unstable; urgency=low

  * Update standards-version to 3.7.3, and debhelper compatibility level
    to 6. No changes.
  * Move Homepage from the package description to a regular
    debian/control field.
  * Don't ignore distclean errors in debian/rules.
  * Don't ship the BUGS file, as it's out of date. Also drop the README,
    as the manpage is more current and has all of the same information.

  * Change the default button spec for clarity. Since X now considers
    everyone to have a horizontal mouse wheel when numbering buttons, we now
    skip over four buttons before we get to the thumb buttons. Update the
    README.Debian to match, and add a NEWS.Debian entry to explain.
  * Revamp the default imwheelrc and manpage, mainly cleaning up and deleting
    references to deprecated options. Also edit these options out of the
    ouput of 'imwheel -h'.

 -- Christopher Martin <chrsmrtn@debian.org>  Mon, 28 Jan 2008 19:26:41 -0500

imwheel (1.0.0pre12-7) unstable; urgency=low

  * Improve the last patch slightly, by once again allowing imwheel to be
    started without the '-b' option. Many people don't use this option
    since they are happy with the default ("4 5 6 7 8 9"), and therefore the
    last upload caused imwheel to fail to start for them. Now the old
    behaviour is restored, though if you do use the '-b' option, you
    still need to add the spaces between the numbers. (Closes: #359685)

 -- Christopher Martin <chrsmrtn@debian.org>  Tue, 28 Mar 2006 10:41:24 -0500

imwheel (1.0.0pre12-6) unstable; urgency=low

  * Apply a patch from Thomas Liebetraut <thomas@tommie-lie.de> that
    allows imwheel to control more than 9 buttons. This requires that
    the button spec format be changed, however. Each button number must
    now be separated by a space (so "0089" becomes "0 0 8 9"). Update
    the documentation to reflect this change. Add a NEWS.Debian to
    explain the changes in more detail. (Closes: #203006)



=== debian/control ===
Source: imwheel
Section: x11
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 13), libx11-dev, libxmu-dev, libxtst-dev
Standards-Version: 4.6.0
Homepage: http://imwheel.sourceforge.net
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/imwheel
Vcs-Git: https://salsa.debian.org/debian/imwheel.git

Package: imwheel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: add support to non-standard buttons on mouse in Linux
 Many mice have side or "thumb" buttons that see limited use in Linux,
 as well as a wheel that is not used by many older applications.
 .
 IMWheel supports these non-standard buttons and/or wheel operations
 by allowing the user to map their input to specific key combinations
 depending on the application in use.

=== debian/tests/control ===
Test-Command: imwheel --help
Restrictions: superficial

=== debian/watch ===
version=4
http://sf.net/imwheel/ imwheel-(\d\S+)\.tar\.(?:bz2|gz|xz)
